"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var classnames = require("classnames");
var pure_1 = require("../../utils/pure");
var LoadingIndicator_1 = require("../LoadingIndicator/LoadingIndicator");
var withTheme_1 = require("../../utils/withTheme");
exports.BUTTON = Symbol('Button');
var RawButton = /** @class */function (_super) {
    tslib_1.__extends(RawButton, _super);
    function RawButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawButton.prototype.render = function () {
        var _a = this.props,
            theme = _a.theme,
            style = _a.style,
            type = _a.type,
            children = _a.children,
            onClick = _a.onClick,
            onMouseDown = _a.onMouseDown,
            onMouseLeave = _a.onMouseLeave,
            onMouseUp = _a.onMouseUp,
            isFlat = _a.isFlat,
            isPrimary = _a.isPrimary,
            isLoading = _a.isLoading,
            isDisabled = _a.isDisabled,
            tabIndex = _a.tabIndex;
        var className = classnames(theme.container, (_b = {}, _b[theme.container_primary] = isPrimary, _b[theme.container_flat] = isFlat, _b[theme.container_isLoading] = isLoading, _b));
        return React.createElement("button", { className: className, onClick: onClick, onMouseLeave: onMouseLeave, onMouseDown: onMouseDown, onMouseUp: onMouseUp, type: type, style: style, tabIndex: tabIndex, disabled: isDisabled }, children, isLoading && React.createElement("div", { className: theme.loadingIndicator }, React.createElement(LoadingIndicator_1.LoadingIndicator, { theme: theme.LoadingIndicator })));
        var _b;
    };
    RawButton.defaultProps = {
        type: 'button'
    };
    RawButton = tslib_1.__decorate([pure_1.PURE], RawButton);
    return RawButton;
}(React.Component);
exports.Button = withTheme_1.withTheme(exports.BUTTON)(RawButton);