"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var pure_1 = require("../../utils/pure");
var classnames = require("classnames");
var withTheme_1 = require("../../utils/withTheme");
exports.LINK = Symbol('Link');
var RawLink = /** @class */function (_super) {
    tslib_1.__extends(RawLink, _super);
    function RawLink() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClick = function (e) {
            if (_this.props.isDisabled || !_this.props.processEmptyHash && _this.props.href === '#') {
                e.preventDefault();
            }
            _this.props.onClick && _this.props.onClick(e);
        };
        return _this;
    }
    RawLink.prototype.render = function () {
        var _a = this.props,
            isDisabled = _a.isDisabled,
            rel = _a.rel,
            href = _a.href,
            target = _a.target,
            children = _a.children,
            theme = _a.theme,
            download = _a.download;
        var className = classnames(theme.container, (_b = {}, _b[theme.container_isDisabled] = isDisabled, _b));
        return React.createElement("a", { href: href, download: download, rel: rel, target: target, onClick: this.onClick, className: className }, children);
        var _b;
    };
    RawLink = tslib_1.__decorate([pure_1.PURE], RawLink);
    return RawLink;
}(React.Component);
exports.Link = withTheme_1.withTheme(exports.LINK)(RawLink);