"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var List_1 = require("../List/List");
var withTheme_1 = require("../../utils/withTheme");
var react_1 = require("react");
var pure_1 = require("../../utils/pure");
var classnames = require("classnames");
var Pure_1 = require("../Pure/Pure");
exports.MENU = Symbol('Menu');
var RawMenu = /** @class */function (_super) {
    tslib_1.__extends(RawMenu, _super);
    function RawMenu() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawMenu.prototype.render = function () {
        var _this = this;
        var _a = this.props,
            children = _a.children,
            List = _a.List;
        return React.createElement(List, tslib_1.__assign({}, this.props), React.Children.map(children, function (child) {
            var props = {
                onSelect: _this.props.onItemSelect
            };
            return React.cloneElement(child, props);
        }));
    };
    RawMenu.defaultProps = {
        List: List_1.List
    };
    return RawMenu;
}(React.Component);
exports.Menu = withTheme_1.withTheme(exports.MENU)(RawMenu);
var RawMenuItem = /** @class */function (_super) {
    tslib_1.__extends(RawMenuItem, _super);
    function RawMenuItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClick = function () {
            _this.props.onSelect && _this.props.onSelect(_this.props.value);
        };
        return _this;
    }
    RawMenuItem.prototype.render = function () {
        var _a = this.props,
            isActive = _a.isActive,
            ListItem = _a.ListItem;
        var theme = this.props.theme;
        if (isActive) {
            theme = tslib_1.__assign({}, theme, { item: classnames(theme.item, theme.item_active) });
        }
        return React.createElement(ListItem, tslib_1.__assign({ onClick: this.onClick }, this.props, { theme: theme }), React.createElement("div", { className: theme.item__content }, this.props.children));
    };
    RawMenuItem.defaultProps = {
        ListItem: List_1.ListItem
    };
    RawMenuItem = tslib_1.__decorate([pure_1.PURE], RawMenuItem);
    return RawMenuItem;
}(react_1.Component);
exports.MenuItem = withTheme_1.withTheme(exports.MENU)(RawMenuItem);
var RawMenuItemGroup = /** @class */function (_super) {
    tslib_1.__extends(RawMenuItemGroup, _super);
    function RawMenuItemGroup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isCollapsed: true
        };
        _this.onClick = function () {
            _this.setState({
                isCollapsed: !_this.state.isCollapsed
            });
        };
        return _this;
    }
    RawMenuItemGroup.prototype.componentWillMount = function () {
        this.setState({
            isCollapsed: this.props.isCollapsed
        });
    };
    RawMenuItemGroup.prototype.componentWillReceiveProps = function (props) {
        this.setState({
            isCollapsed: props.isCollapsed
        });
    };
    RawMenuItemGroup.prototype.render = function () {
        var _this = this;
        var _a = this.props,
            children = _a.children,
            theme = _a.theme,
            ListItemGroup = _a.ListItemGroup;
        var header;
        if (this.props.header) {
            header = React.createElement("div", { className: theme.itemGroup__header__content }, this.props.header);
        }
        return React.createElement(ListItemGroup, tslib_1.__assign({ onClick: this.onClick }, this.props, { header: header, isCollapsed: this.state.isCollapsed }), React.createElement(Pure_1.Pure, { check: children }, function () {
            return React.cloneElement(React.Children.only(children), {
                onItemSelect: _this.props.onSelect
            });
        }));
    };
    RawMenuItemGroup.defaultProps = {
        ListItemGroup: List_1.ListItemGroup,
        List: exports.Menu,
        isCollapsed: true //menu is always collapsed
    };
    RawMenuItemGroup = tslib_1.__decorate([pure_1.PURE], RawMenuItemGroup);
    return RawMenuItemGroup;
}(React.Component);
exports.MenuItemGroup = withTheme_1.withTheme(exports.MENU)(RawMenuItemGroup);