"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var pure_1 = require("../../utils/pure");
var classnames = require("classnames");
var Portal = require("react-overlays/lib/Portal");
var PropTypes = require("prop-types");
var react_1 = require("react");
var withTheme_1 = require("../../utils/withTheme");
var RootClose_1 = require("../RootClose/RootClose");
exports.POPUP = Symbol('Popup');
exports.POPUP_THEME_SHAPE_OBJECT = {
    container: PropTypes.string,
    header: PropTypes.string,
    body: PropTypes.string,
    footer: PropTypes.string
};
var RawPopup = /** @class */function (_super) {
    tslib_1.__extends(RawPopup, _super);
    function RawPopup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleBackdropClick = function (e) {
            var _a = _this.props,
                shouldCloseOnClickAway = _a.shouldCloseOnClickAway,
                onRequestClose = _a.onRequestClose;
            if (shouldCloseOnClickAway && onRequestClose) {
                var isModal = _this.props.isModal;
                if (isModal) {
                    //popup is modal - backdrop handles clicks
                    //don't process click inside popup container (bubbled events)
                    if (e.target === _this.backdrop) {
                        onRequestClose();
                    }
                }
                //if popup isn't modal then it's closed by RootClose
            }
        };
        return _this;
    }
    RawPopup.prototype.render = function () {
        var _this = this;
        var _a = this.props,
            theme = _a.theme,
            header = _a.header,
            children = _a.children,
            footer = _a.footer,
            isModal = _a.isModal,
            container = _a.container,
            isOpened = _a.isOpened,
            shouldCloseOnClickAway = _a.shouldCloseOnClickAway,
            onRequestClose = _a.onRequestClose;
        if (!isOpened) {
            return null;
        }
        var backdropClassName = classnames(theme.backdrop, (_b = {}, _b[theme.backdrop_isModal] = isModal, _b[theme.backdrop_closeOnClickAway] = shouldCloseOnClickAway, _b));
        var child = React.createElement(RootClose_1.RootClose, { onRootClose: onRequestClose, ignoreKeyUp: !shouldCloseOnClickAway, ignoreClick: !shouldCloseOnClickAway || isModal }, React.createElement("div", { className: backdropClassName, ref: function ref(el) {
                return _this.backdrop = el;
            }, onClick: this.handleBackdropClick }, React.createElement("div", { className: theme.container }, header && React.createElement("div", { className: theme.header }, header), React.createElement("div", { className: theme.body }, children), footer && React.createElement("div", { className: theme.footer }, footer))));
        // //if popup is modal then it should be closed only on click on backdrop
        // //if popup isn't modal then backdrop has pointer-events: none and click should be detected by RootClose
        // if (shouldCloseOnClickAway) {
        // 	child = (
        // 		<RootClose ignoreClick={isModal}>
        // 			{child}
        // 		</RootClose>
        // 	);
        // }
        child = React.createElement(Portal, { container: container }, child);
        return child;
        var _b;
    };
    RawPopup = tslib_1.__decorate([pure_1.PURE], RawPopup);
    return RawPopup;
}(react_1.Component);
exports.Popup = withTheme_1.withTheme(exports.POPUP)(RawPopup);