"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("react");
var pure_1 = require("../../utils/pure");
var classnames = require("classnames");
var withTheme_1 = require("../../utils/withTheme");
exports.TOGGLE_BUTTONS = Symbol('ToggleButtons');
var RawToggleButtons = /** @class */function (_super) {
    tslib_1.__extends(RawToggleButtons, _super);
    function RawToggleButtons() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            toggleIndex: 0
        };
        _this.renderToggleItem = function (child, i) {
            var _a = _this.props,
                theme = _a.theme,
                isVertical = _a.isVertical,
                isDisabled = _a.isDisabled;
            var isActive = i === _this.state.toggleIndex;
            var toggleButtonTheme = withTheme_1.mergeThemes({
                container: classnames(theme.container__item, (_b = {}, _b[theme.container__item_active] = isActive, _b[theme.container__vertical] = isVertical, _b))
            }, child.props.theme || {});
            var childProps = Object.assign({}, child.props, {
                isActive: isActive,
                isDisabled: isDisabled,
                onClick: _this.onToggleSelect(i, child.props.onClick),
                theme: toggleButtonTheme
            });
            return React.cloneElement(child, childProps);
            var _b;
        };
        _this.onToggleSelect = function (toggleIndex, childClickHandler) {
            return function () {
                if (typeof _this.props.toggleIndex === 'undefined') {
                    _this.setState({
                        toggleIndex: toggleIndex
                    });
                }
                childClickHandler && childClickHandler();
                _this.props.onChange && _this.props.onChange(toggleIndex);
            };
        };
        return _this;
    }
    RawToggleButtons.prototype.componentWillMount = function () {
        var _a = this.props,
            toggleIndex = _a.toggleIndex,
            defaultIndex = _a.defaultIndex;
        this.setState({
            toggleIndex: typeof toggleIndex !== 'undefined' ? toggleIndex : defaultIndex || 0
        });
    };
    RawToggleButtons.prototype.componentWillReceiveProps = function (newProps) {
        if (typeof newProps.toggleIndex !== 'undefined') {
            this.setState({
                toggleIndex: newProps.toggleIndex
            });
        }
    };
    RawToggleButtons.prototype.render = function () {
        var _a = this.props,
            children = _a.children,
            theme = _a.theme;
        return React.createElement("div", { className: theme.container__wrapper }, React.Children.map(children, this.renderToggleItem));
    };
    RawToggleButtons.propTypes = {
        children: react_1.PropTypes.arrayOf(react_1.PropTypes.element),
        isDisabled: react_1.PropTypes.bool,
        isVertical: react_1.PropTypes.bool,
        toggleIndex: react_1.PropTypes.number,
        defaultIndex: react_1.PropTypes.number,
        onChange: react_1.PropTypes.func,
        theme: react_1.PropTypes.shape({
            container: react_1.PropTypes.string,
            container__wrapper: react_1.PropTypes.string,
            container__vertical: react_1.PropTypes.string,
            container__item: react_1.PropTypes.string,
            container__item_active: react_1.PropTypes.string
        })
    };
    RawToggleButtons = tslib_1.__decorate([pure_1.PURE], RawToggleButtons);
    return RawToggleButtons;
}(react_1.Component);
exports.ToggleButtons = withTheme_1.withTheme(exports.TOGGLE_BUTTONS)(RawToggleButtons);