/// <reference types="react" />
import * as React from 'react';
import { Component } from 'react';
import * as PropTypes from 'prop-types';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare type TTheme = {
    [key: string]: TTheme | string | undefined;
};
export declare const withTheme: (name: string | symbol, defaultTheme?: TTheme) => <P extends {
    theme?: TTheme | undefined;
}>(Target: React.ComponentType<P>) => React.ComponentClass<PartialKeys<P & {
    withRef?: string | ((instance: any) => any) | undefined;
}, "theme">>;
/**
 * Merges passed themes by concatenating string keys and processing nested themes
 */
export declare function mergeThemes(...themes: TTheme[]): TTheme;
export declare type TThemeProviderProps = {
    theme: {
        [key: string]: TTheme;
    };
};
export declare class ThemeProvider extends Component<TThemeProviderProps> {
    static childContextTypes: {
        [x: string]: PropTypes.Requireable<any>;
    };
    render(): React.ReactElement<any>;
    getChildContext(): {
        [x: string]: {
            [key: string]: TTheme;
        };
    };
}
