'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.KEY_CODE_NUM_MAP = exports.KeyCode = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _KEY_CODE_NUM_MAP;

exports.createControlProps = createControlProps;
exports.stateful = stateful;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var PropTypes = _interopRequireWildcard(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createControlProps(valueType) {
    return {
        value: valueType,
        onChange: PropTypes.func
    };
}
var KeyCode = exports.KeyCode = undefined;
(function (KeyCode) {
    KeyCode[KeyCode["Escape"] = 27] = "Escape";
    KeyCode[KeyCode["Left"] = 37] = "Left";
    KeyCode[KeyCode["Right"] = 39] = "Right";
    KeyCode[KeyCode["Delete"] = 46] = "Delete";
    KeyCode[KeyCode["Backspace"] = 8] = "Backspace";
    KeyCode[KeyCode["N0"] = 48] = "N0";
    KeyCode[KeyCode["N1"] = 49] = "N1";
    KeyCode[KeyCode["N2"] = 50] = "N2";
    KeyCode[KeyCode["N3"] = 51] = "N3";
    KeyCode[KeyCode["N4"] = 52] = "N4";
    KeyCode[KeyCode["N5"] = 53] = "N5";
    KeyCode[KeyCode["N6"] = 54] = "N6";
    KeyCode[KeyCode["N7"] = 55] = "N7";
    KeyCode[KeyCode["N8"] = 56] = "N8";
    KeyCode[KeyCode["N9"] = 57] = "N9";
    KeyCode[KeyCode["NUM0"] = 96] = "NUM0";
    KeyCode[KeyCode["NUM1"] = 97] = "NUM1";
    KeyCode[KeyCode["NUM2"] = 98] = "NUM2";
    KeyCode[KeyCode["NUM3"] = 99] = "NUM3";
    KeyCode[KeyCode["NUM4"] = 100] = "NUM4";
    KeyCode[KeyCode["NUM5"] = 101] = "NUM5";
    KeyCode[KeyCode["NUM6"] = 102] = "NUM6";
    KeyCode[KeyCode["NUM7"] = 103] = "NUM7";
    KeyCode[KeyCode["NUM8"] = 104] = "NUM8";
    KeyCode[KeyCode["NUM9"] = 105] = "NUM9";
})(KeyCode || (exports.KeyCode = KeyCode = {}));
var KEY_CODE_NUM_MAP = exports.KEY_CODE_NUM_MAP = (_KEY_CODE_NUM_MAP = {}, _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N0, 0), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N1, 1), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N2, 2), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N3, 3), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N4, 4), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N5, 5), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N6, 6), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N7, 7), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N8, 8), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.N9, 9), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM0, 0), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM1, 1), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM2, 2), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM3, 3), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM4, 4), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM5, 5), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM6, 6), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM7, 7), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM8, 8), _defineProperty(_KEY_CODE_NUM_MAP, KeyCode.NUM9, 9), _KEY_CODE_NUM_MAP);
function stateful() {
    var valueName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'value';
    var handlerName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'onValueChange';
    var defaultValueName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'defaultValue';

    return function decorate(Target) {
        var Stateful = function (_React$Component) {
            _inherits(Stateful, _React$Component);

            function Stateful() {
                _classCallCheck(this, Stateful);

                var _this = _possibleConstructorReturn(this, (Stateful.__proto__ || Object.getPrototypeOf(Stateful)).apply(this, arguments));

                _this.onValueChange = function (value) {
                    _this.setState({
                        value: value
                    });
                    var onValueChange = _this.props[handlerName];
                    onValueChange && onValueChange(value);
                };
                return _this;
            }

            _createClass(Stateful, [{
                key: 'componentWillMount',
                value: function componentWillMount() {
                    this.setState({
                        value: this.props[defaultValueName]
                    });
                }
            }, {
                key: 'render',
                value: function render() {
                    var _Object$assign;

                    var props = Object.assign({}, this.props, (_Object$assign = {}, _defineProperty(_Object$assign, valueName, this.state.value), _defineProperty(_Object$assign, handlerName, this.onValueChange), _Object$assign));
                    //tslint:disable-next-line no-any - fix for react typings
                    return React.createElement(Target, props);
                }
            }]);

            return Stateful;
        }(React.Component);

        Stateful.displayName = 'Stateful(' + (Target.displayName || Target.name || 'Component') + ')';
        return Stateful;
    };
}
//tslint:enable max-line-length