/// <reference types="react" />
import * as React from 'react';
import { MouseEvent, EventHandler, ComponentClass } from 'react';
import { PartialKeys } from '@devexperts/utils/lib/object/object';
import { ObjectClean } from 'typelevel-ts/lib';
export declare const LINK: symbol;
export declare type TFullLinkProps = {
    children: React.ReactNode;
    href?: string;
    target?: string;
    rel?: string;
    download?: string;
    isDisabled?: boolean;
    processEmptyHash?: boolean;
    onClick?: EventHandler<MouseEvent<HTMLAnchorElement>>;
    theme: {
        container?: string;
        container_isDisabled?: string;
    };
};
export declare type TLinkProps = ObjectClean<PartialKeys<TFullLinkProps, 'theme'>>;
export declare const Link: ComponentClass<TLinkProps>;
