'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Popover = exports.PopoverAlign = exports.PopoverPlacement = exports.POPOVER = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var ReactDOM = _interopRequireWildcard(_reactDom);

var _Portal = require('react-overlays/lib/Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _prefix = require('@devexperts/utils/lib/dom/prefix');

var _prefix2 = _interopRequireDefault(_prefix);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _pure = require('../../utils/pure');

var _BoundsUpdateDetector = require('../BoundsUpdateDetector/BoundsUpdateDetector');

var _throttle = require('@devexperts/utils/lib/function/throttle');

var _withTheme = require('../../utils/withTheme');

var _EventListener = require('../EventListener/EventListener');

var _RootClose = require('../RootClose/RootClose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var POPOVER = exports.POPOVER = Symbol('Popover');
var PopoverPlacement = exports.PopoverPlacement = undefined;
(function (PopoverPlacement) {
    PopoverPlacement["Top"] = "Top";
    PopoverPlacement["Bottom"] = "Bottom";
    PopoverPlacement["Left"] = "Left";
    PopoverPlacement["Right"] = "Right";
})(PopoverPlacement || (exports.PopoverPlacement = PopoverPlacement = {}));
var PopoverAlign = exports.PopoverAlign = undefined;
(function (PopoverAlign) {
    PopoverAlign["Top"] = "Top";
    PopoverAlign["Bottom"] = "Bottom";
    PopoverAlign["Left"] = "Left";
    PopoverAlign["Right"] = "Right";
    PopoverAlign["Middle"] = "Middle";
    PopoverAlign["Center"] = "Center";
})(PopoverAlign || (exports.PopoverAlign = PopoverAlign = {}));
var RawPopover = function (_React$Component) {
    _inherits(RawPopover, _React$Component);

    function RawPopover() {
        _classCallCheck(this, RawPopover);

        var _this = _possibleConstructorReturn(this, (RawPopover.__proto__ || Object.getPrototypeOf(RawPopover)).apply(this, arguments));

        _this.state = {};
        _this._needsUpdate = false;
        _this.onSizeUpdate = function (newSize) {
            _this._popoverSize = newSize;
            _this.updatePosition();
        };
        _this.onResize = function () {
            _this.handleResize();
        };
        _this.onScroll = function () {
            _this.handleScroll();
        };
        return _this;
    }

    _createClass(RawPopover, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.props.isOpened) {
                if (this.props.anchor) {
                    this._anchor = ReactDOM.findDOMNode(this.props.anchor);
                }
                this._popoverSize = this.getPopoverSize();
                this.updatePosition();
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.isOpened && nextProps.anchor) {
                this._needsUpdate = true;
                this._anchor = ReactDOM.findDOMNode(nextProps.anchor);
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            //@PURE check is passed here - update anyway
            if (this._needsUpdate) {
                /** set in {@link componentWillReceiveProps} */
                this._needsUpdate = false;
                this._popoverSize = this.getPopoverSize();
                this.updatePosition();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                container = _props.container,
                closeOnClickAway = _props.closeOnClickAway,
                theme = _props.theme,
                hasArrow = _props.hasArrow,
                onMouseDown = _props.onMouseDown,
                isOpened = _props.isOpened,
                onRequestClose = _props.onRequestClose,
                anchor = _props.anchor;

            if (!isOpened || !anchor) {
                return null;
            }
            var _state = this.state,
                top = _state.top,
                left = _state.left,
                arrowOffset = _state.arrowOffset,
                finalPlacement = _state.finalPlacement,
                finalAlign = _state.finalAlign;

            var isMeasured = !!finalAlign && !!finalPlacement;
            var style = void 0;
            var popoverClassName = (0, _classnames3.default)(theme.container);
            if (isMeasured && finalPlacement) {
                style = (0, _prefix2.default)({
                    transform: 'translate(' + (left || 0) + 'px, ' + (top || 0) + 'px)'
                });
                popoverClassName = (0, _classnames3.default)(popoverClassName, _defineProperty({}, theme.container_hasArrow, hasArrow), [getPlacementModifier(finalPlacement)].map(function (mod) {
                    return theme['container_' + mod];
                }));
            }
            style = Object.assign({}, style, this.props.style);
            var child = React.createElement(_BoundsUpdateDetector.BoundsUpdateDetector, { onUpdate: this.onSizeUpdate }, React.createElement("div", { ref: function ref(el) {
                    return _this2._popover = el;
                }, style: style, onMouseDown: onMouseDown, className: popoverClassName }, React.createElement("div", { className: theme.content }, isMeasured && finalPlacement && finalAlign && hasArrow && React.createElement("div", { className: theme.arrow, style: getArrowStyle(finalPlacement, finalAlign, arrowOffset) }), this.props.children)));
            if (closeOnClickAway) {
                child = React.createElement(_RootClose.RootClose, { onRootClose: onRequestClose }, child);
            }
            return React.createElement(_EventListener.EventListener, { onResize: this.onResize, onScroll: this.onScroll, target: "window" }, React.createElement(_Portal2.default, { container: container }, child));
        }
    }, {
        key: 'getPopoverSize',
        value: function getPopoverSize() {
            var popover = ReactDOM.findDOMNode(this._popover);
            return {
                height: popover.offsetHeight,
                width: popover.offsetWidth
            };
        }
    }, {
        key: 'updatePosition',
        value: function updatePosition() {
            if (!this._anchor) {
                return;
            }
            var anchorRect = this._anchor.getBoundingClientRect();
            var _props2 = this.props,
                placement = _props2.placement,
                align = _props2.align,
                hasArrow = _props2.hasArrow;

            var arrowOffset = void 0;
            var finalPlacement = void 0;
            var finalAlign = void 0;
            var topResult = movePopoverVertically(placement, align, anchorRect.top, anchorRect.bottom, this._popoverSize.height, true);
            var leftResult = movePopoverHorizontally(placement, align, anchorRect.left, anchorRect.right, this._popoverSize.width, true);
            //additional
            if (placement === PopoverPlacement.Top || placement === PopoverPlacement.Bottom) {
                finalPlacement = topResult.placement;
                finalAlign = leftResult.align;
                if (hasArrow) {
                    //horizontal arrow offset
                    arrowOffset = Math.round((anchorRect.right - anchorRect.left) / 2);
                }
            } else if (placement === PopoverPlacement.Left || placement === PopoverPlacement.Right) {
                finalPlacement = leftResult.placement;
                finalAlign = topResult.align;
                if (hasArrow) {
                    //vertical arrow offset
                    arrowOffset = Math.round((anchorRect.bottom - anchorRect.top) / 2);
                }
            }
            this.setState({
                top: Math.round(topResult.top) + window.pageYOffset,
                left: Math.round(leftResult.left) + window.pageXOffset,
                finalPlacement: finalPlacement,
                finalAlign: finalAlign,
                arrowOffset: arrowOffset
            });
        }
    }, {
        key: 'handleResize',
        value: function handleResize() {
            this.updatePosition();
        }
    }, {
        key: 'handleScroll',
        value: function handleScroll() {
            this.updatePosition();
        }
    }]);

    return RawPopover;
}(React.Component);
RawPopover.defaultProps = {
    align: PopoverAlign.Left,
    placement: PopoverPlacement.Bottom
};
tslib_1.__decorate([(0, _throttle.THROTTLE)(100), tslib_1.__metadata("design:type", Function), tslib_1.__metadata("design:paramtypes", []), tslib_1.__metadata("design:returntype", void 0)], RawPopover.prototype, "handleResize", null);
tslib_1.__decorate([(0, _throttle.THROTTLE)(100), tslib_1.__metadata("design:type", Function), tslib_1.__metadata("design:paramtypes", []), tslib_1.__metadata("design:returntype", void 0)], RawPopover.prototype, "handleScroll", null);
RawPopover = tslib_1.__decorate([_pure.PURE], RawPopover);
var Popover = exports.Popover = (0, _withTheme.withTheme)(POPOVER)(RawPopover);
function getArrowStyle(placement, align, offset) {
    switch (placement) {
        case PopoverPlacement.Top: //fallthrough
        case PopoverPlacement.Bottom:
            {
                switch (align) {
                    case PopoverAlign.Left:
                        {
                            return (0, _prefix2.default)({
                                left: offset,
                                transform: 'translateX(-50%)'
                            });
                        }
                    case PopoverAlign.Center:
                        {
                            return (0, _prefix2.default)({
                                left: '50%',
                                transform: 'translateX(-50%)'
                            });
                        }
                    case PopoverAlign.Right:
                        {
                            return (0, _prefix2.default)({
                                right: offset,
                                transform: 'translateX(50%)'
                            });
                        }
                }
                break;
            }
        case PopoverPlacement.Left: //fallthrough
        case PopoverPlacement.Right:
            {
                switch (align) {
                    case PopoverAlign.Top:
                        {
                            return (0, _prefix2.default)({
                                top: offset,
                                transform: 'translateY(-50%)'
                            });
                        }
                    case PopoverAlign.Middle:
                        {
                            return (0, _prefix2.default)({
                                top: '50%',
                                transform: 'translateY(-50%)'
                            });
                        }
                    case PopoverAlign.Bottom:
                        {
                            return (0, _prefix2.default)({
                                bottom: offset,
                                transform: 'translateY(50%)'
                            });
                        }
                }
            }
    }
    return undefined;
}
function movePopoverVertically(placement, align, anchorTop, anchorBottom, popoverHeight) {
    var checkBounds = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;

    switch (placement) {
        case PopoverPlacement.Top:
            {
                var top = anchorTop - popoverHeight;
                if (checkBounds && top < 0) {
                    return movePopoverVertically(PopoverPlacement.Bottom, align, anchorTop, anchorBottom, popoverHeight);
                }
                return {
                    top: top,
                    placement: placement,
                    align: align
                };
            }
        case PopoverPlacement.Bottom:
            {
                var _top = anchorBottom;
                if (checkBounds && _top + popoverHeight > window.innerHeight) {
                    return movePopoverVertically(PopoverPlacement.Top, align, anchorTop, anchorBottom, popoverHeight);
                }
                return {
                    top: _top,
                    placement: placement,
                    align: align
                };
            }
    }
    switch (align) {
        case PopoverAlign.Top:
            {
                var _top2 = anchorTop;
                if (checkBounds && _top2 + popoverHeight > window.innerHeight) {
                    var resultForMiddle = movePopoverVertically(placement, PopoverAlign.Middle, anchorTop, anchorBottom, popoverHeight);
                    if (resultForMiddle && resultForMiddle.top + popoverHeight > window.innerHeight) {
                        return movePopoverVertically(placement, PopoverAlign.Bottom, anchorTop, anchorBottom, popoverHeight);
                    }
                    return resultForMiddle;
                }
                return {
                    top: _top2,
                    placement: placement,
                    align: align
                };
            }
        case PopoverAlign.Middle:
            {
                var _top3 = anchorTop + (anchorBottom - anchorTop) / 2 - popoverHeight / 2;
                if (checkBounds) {
                    if (_top3 < 0) {
                        return movePopoverVertically(placement, PopoverAlign.Top, anchorTop, anchorBottom, popoverHeight);
                    } else if (_top3 + popoverHeight > window.innerHeight) {
                        return movePopoverVertically(placement, PopoverAlign.Bottom, anchorTop, anchorBottom, popoverHeight);
                    }
                }
                return {
                    top: _top3,
                    placement: placement,
                    align: align
                };
            }
        case PopoverAlign.Bottom:
            {
                var _top4 = anchorBottom - popoverHeight;
                if (checkBounds && _top4 < 0) {
                    var _resultForMiddle = movePopoverVertically(placement, PopoverAlign.Middle, anchorTop, anchorBottom, popoverHeight);
                    if (_resultForMiddle && _resultForMiddle.top < 0) {
                        return movePopoverVertically(placement, PopoverAlign.Top, anchorTop, anchorBottom, popoverHeight);
                    }
                    return _resultForMiddle;
                }
                return {
                    top: _top4,
                    placement: placement,
                    align: align
                };
            }
    }
    return undefined;
}
function movePopoverHorizontally(placement, align, anchorLeft, anchorRight, popoverWidth) {
    var checkBounds = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;

    switch (placement) {
        case PopoverPlacement.Left:
            {
                var left = anchorLeft - popoverWidth;
                if (checkBounds && left < 0) {
                    return movePopoverHorizontally(PopoverPlacement.Right, align, anchorLeft, anchorRight, popoverWidth);
                }
                return {
                    left: left,
                    placement: placement,
                    align: align
                };
            }
        case PopoverPlacement.Right:
            {
                var _left = anchorRight;
                if (checkBounds && _left + popoverWidth > window.innerWidth) {
                    return movePopoverHorizontally(PopoverPlacement.Left, align, anchorLeft, anchorRight, popoverWidth);
                }
                return {
                    left: _left,
                    placement: placement,
                    align: align
                };
            }
    }
    switch (align) {
        case PopoverAlign.Left:
            {
                var _left2 = anchorLeft;
                if (checkBounds && _left2 + popoverWidth > window.innerWidth) {
                    var resultForCenter = movePopoverHorizontally(placement, PopoverAlign.Center, anchorLeft, anchorRight, popoverWidth);
                    if (resultForCenter && resultForCenter.left + popoverWidth > window.innerWidth) {
                        return movePopoverHorizontally(placement, PopoverAlign.Right, anchorLeft, anchorRight, popoverWidth);
                    }
                    return resultForCenter;
                }
                return {
                    left: _left2,
                    placement: placement,
                    align: align
                };
            }
        case PopoverAlign.Center:
            {
                var _left3 = anchorLeft + (anchorRight - anchorLeft) / 2 - popoverWidth / 2;
                if (checkBounds) {
                    if (_left3 < 0) {
                        return movePopoverHorizontally(placement, PopoverAlign.Left, anchorLeft, anchorRight, popoverWidth);
                    } else if (_left3 + popoverWidth > window.innerWidth) {
                        return movePopoverHorizontally(placement, PopoverAlign.Right, anchorLeft, anchorRight, popoverWidth);
                    }
                }
                return {
                    left: _left3,
                    placement: placement,
                    align: align
                };
            }
        case PopoverAlign.Right:
            {
                var _left4 = anchorRight - popoverWidth;
                if (checkBounds && _left4 < 0) {
                    var _resultForCenter = movePopoverHorizontally(placement, PopoverAlign.Center, anchorLeft, anchorRight, popoverWidth);
                    if (_resultForCenter && _resultForCenter.left < 0) {
                        return movePopoverHorizontally(placement, PopoverAlign.Left, anchorLeft, anchorRight, popoverWidth);
                    }
                    return _resultForCenter;
                }
                return {
                    left: _left4,
                    placement: placement,
                    align: align
                };
            }
    }
    return undefined;
}
function getPlacementModifier(placement) {
    switch (placement) {
        case PopoverPlacement.Bottom:
            {
                return 'placementBottom';
            }
        case PopoverPlacement.Top:
            {
                return 'placementTop';
            }
        case PopoverPlacement.Left:
            {
                return 'placementLeft';
            }
        case PopoverPlacement.Right:
            {
                return 'placementRight';
            }
    }
}