/// <reference types="react" />
import * as React from 'react';
import * as PropTypes from 'prop-types';
import { ReactNode } from 'react';
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/lib/object/object';
export declare const POPUP: symbol;
export declare type TRawPopupProps = {
    theme: {
        container?: string;
        header?: string;
        body?: string;
        footer?: string;
        backdrop?: string;
        backdrop_isModal?: string;
        backdrop_closeOnClickAway?: string;
    };
    children: ReactNode;
    header?: ReactNode;
    footer?: ReactNode;
    isModal?: boolean;
    isOpened?: boolean;
    shouldCloseOnClickAway?: boolean;
    onRequestClose?: () => any;
    container: ReactOverlays.Portal.TPortalProps['container'];
};
export declare const POPUP_THEME_SHAPE_OBJECT: {
    container: PropTypes.Requireable<any>;
    header: PropTypes.Requireable<any>;
    body: PropTypes.Requireable<any>;
    footer: PropTypes.Requireable<any>;
};
export declare type TPopupProps = ObjectClean<PartialKeys<TRawPopupProps, 'theme'>>;
export declare const Popup: React.ComponentClass<PartialKeys<TRawPopupProps & {
    withRef?: string | ((instance: any) => any) | undefined;
}, "theme">>;
