'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Scrollbar = exports.SCROLLBAR_TYPE = exports.SCROLLBAR = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Bar = require('./Bar');

var _Scrollable = require('../Scrollable/Scrollable.const');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCROLLBAR = exports.SCROLLBAR = Symbol('Scrollbar');
var SCROLLBAR_TYPE = exports.SCROLLBAR_TYPE = undefined;
(function (SCROLLBAR_TYPE) {
    SCROLLBAR_TYPE["HORIZONTAL"] = "HORIZONTAL";
    SCROLLBAR_TYPE["VERTICAL"] = "VERTICAL";
})(SCROLLBAR_TYPE || (exports.SCROLLBAR_TYPE = SCROLLBAR_TYPE = {}));
;

var Scrollbar = exports.Scrollbar = function (_React$Component) {
    _inherits(Scrollbar, _React$Component);

    function Scrollbar() {
        var _ref;

        _classCallCheck(this, Scrollbar);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var _this = _possibleConstructorReturn(this, (_ref = Scrollbar.__proto__ || Object.getPrototypeOf(Scrollbar)).call.apply(_ref, [this].concat(args)));

        _this.state = {
            isVisible: false
        };
        /**
         * @param {Event} event
         * @private
         */
        _this._onContainerScroll = function (event) {
            _this._updateBar();
            var emitter = _this.context[_Scrollable.SCROLLABLE_CONTEXT_EMITTER];
            emitter.emit(_Scrollable.EVENT_SCROLABLE.SCROLL, event);
        };
        _this.onResize = function () {
            _this._update();
        };
        ////////////////////////
        // DOM EVENT HANDLERS //
        ////////////////////////
        /**
         * @abstract
         * @param {WheelEvent} event
         * @protected
         */
        _this.onTrackMouseWheel = function (event) {};
        /**
         * @abstract
         * @param {MouseEvent} event
         * @protected
         */
        _this.onTrackClick = function (event) {};
        /**
         * @abstract
         * @param {MouseEvent} event
         * @protected
         */
        _this.onBarDragStart = function (event) {};
        /**
         * @abstract
         * @param {MouseEvent} event
         * @protected
         */
        _this.onBarDrag = function (event) {};
        var container = _this.props.container;

        _this._container = container;
        return _this;
    }

    _createClass(Scrollbar, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var emitter = this.context[_Scrollable.SCROLLABLE_CONTEXT_EMITTER];
            emitter.on(_Scrollable.EVENT_SCROLABLE.RESIZE, this.onResize);
            if (this._container) {
                this._container.addEventListener('scroll', this._onContainerScroll);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var emitter = this.context[_Scrollable.SCROLLABLE_CONTEXT_EMITTER];
            emitter.off(_Scrollable.EVENT_SCROLABLE.RESIZE, this.onResize);
            if (this._container) {
                this._container.removeEventListener('scroll', this._onContainerScroll);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var theme = this.props.theme;
            var isVisible = this.state.isVisible;

            var className = (0, _classnames3.default)(theme.container, _defineProperty({}, theme.containerIsVisible, isVisible));
            var barProps = {
                theme: {
                    container: theme.bar
                },
                onBarDragStart: this.onBarDragStart,
                onBarDrag: this.onBarDrag
            };
            return React.createElement("div", { className: className, ref: function ref(el) {
                    return _this2._scrollbar = el;
                } }, React.createElement("div", { className: theme.track, onWheel: this.onTrackMouseWheel, onClick: this.onTrackClick, ref: function ref(el) {
                    return _this2._track = el;
                } }, React.createElement(_Bar.Bar, Object.assign({}, barProps, { ref: function ref(el) {
                    return _this2._bar = _reactDom2.default.findDOMNode(el);
                } }))));
        }
    }, {
        key: '_updateBar',
        value: function _updateBar() {}
    }, {
        key: '_update',
        value: function _update() {}
    }]);

    return Scrollbar;
}(React.Component);

Scrollbar.contextTypes = _Scrollable.CONTEXT_TYPES;