'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _storybook = require('@devexperts/tools/lib/utils/storybook');

var _Demo = require('../demo/Demo');

var _Demo2 = _interopRequireDefault(_Demo);

var _Button = require('../Button/Button');

var _Selectbox = require('./Selectbox');

var _SelectboxAnchor = require('./SelectboxAnchor');

var _Menu = require('../Menu/Menu');

var _pure = require('../../utils/pure');

var _listItemTickIcon = require('../../icons/list-item-tick-icon');

var _smallDropdownArrowIcon = require('../../icons/small-dropdown-arrow-icon');

var _Control = require('../Control/Control');

var _SelectboxPage = require('./Selectbox.page.styl');

var selectoxPageCss = _interopRequireWildcard(_SelectboxPage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var wideSelectboxTheme = {
    container__anchor: selectoxPageCss.container__anchor
};

var DemoSelectboxAnchor = function (_React$Component) {
    _inherits(DemoSelectboxAnchor, _React$Component);

    function DemoSelectboxAnchor() {
        _classCallCheck(this, DemoSelectboxAnchor);

        return _possibleConstructorReturn(this, (DemoSelectboxAnchor.__proto__ || Object.getPrototypeOf(DemoSelectboxAnchor)).apply(this, arguments));
    }

    _createClass(DemoSelectboxAnchor, [{
        key: 'render',
        value: function render() {
            var newProps = Object.assign({}, this.props, { isPrimary: true });
            return _react2.default.createElement(_SelectboxAnchor.SelectboxAnchor, Object.assign({}, newProps));
        }
    }]);

    return DemoSelectboxAnchor;
}(_react2.default.Component);

var DemoSelectbox = function (_React$Component2) {
    _inherits(DemoSelectbox, _React$Component2);

    function DemoSelectbox() {
        _classCallCheck(this, DemoSelectbox);

        return _possibleConstructorReturn(this, (DemoSelectbox.__proto__ || Object.getPrototypeOf(DemoSelectbox)).apply(this, arguments));
    }

    _createClass(DemoSelectbox, [{
        key: 'render',
        value: function render() {
            var newProps = Object.assign({}, this.props, { AnchorComponent: DemoSelectboxAnchor, caretIcon: _react2.default.createElement(_smallDropdownArrowIcon.SmallDropDownArrowIcon, null) });
            return _react2.default.createElement(_Selectbox.Selectbox, Object.assign({}, newProps));
        }
    }]);

    return DemoSelectbox;
}(_react2.default.Component);

var Stateful = (0, _Control.stateful)()(DemoSelectbox);
var SelectboxPage = function (_React$Component3) {
    _inherits(SelectboxPage, _React$Component3);

    function SelectboxPage() {
        _classCallCheck(this, SelectboxPage);

        var _this3 = _possibleConstructorReturn(this, (SelectboxPage.__proto__ || Object.getPrototypeOf(SelectboxPage)).apply(this, arguments));

        _this3.state = {
            hero: ''
        };
        _this3.onHeroChange = function (hero) {
            _this3.setState({
                hero: hero
            });
        };
        _this3.onResetClick = function () {
            _this3.setState({
                hero: ''
            });
        };
        return _this3;
    }

    _createClass(SelectboxPage, [{
        key: 'render',
        value: function render() {
            return _react2.default.createElement(_Demo2.default, null, _react2.default.createElement("div", null, _react2.default.createElement(Stateful, { placeholder: "Choose your hero", selectedIcon: _react2.default.createElement(_listItemTickIcon.ListItemTickIcon, null), onValueChange: this.onHeroChange, caretIcon: _react2.default.createElement(_smallDropdownArrowIcon.SmallDropDownArrowIcon, null) }, _react2.default.createElement(_Menu.MenuItem, { value: "superman" }, "Superman"), _react2.default.createElement(_Menu.MenuItem, { value: "batman" }, "Batman"), _react2.default.createElement(_Menu.MenuItem, { value: "flash" }, "Flash")), _react2.default.createElement(DemoSelectbox, { placeholder: "Controlled by left", value: this.state.hero, theme: {}, selectedIcon: _react2.default.createElement(_listItemTickIcon.ListItemTickIcon, null), onValueChange: this.onHeroChange, caretIcon: _react2.default.createElement(_smallDropdownArrowIcon.SmallDropDownArrowIcon, null) }, _react2.default.createElement(_Menu.MenuItem, { value: "superman" }, "Superman"), _react2.default.createElement(_Menu.MenuItem, { value: "batman" }, "Batman"), _react2.default.createElement(_Menu.MenuItem, { value: "flash" }, "Flash")), _react2.default.createElement(Stateful, { placeholder: "Loading", isDisabled: true, isLoading: true }, _react2.default.createElement(_Menu.MenuItem, { value: "dummy" }, "Dummy")), _react2.default.createElement(_Button.Button, { onClick: this.onResetClick }, "Reset")), _react2.default.createElement("section", null, "Sync width", _react2.default.createElement(Stateful, { placeholder: "Choose your hero", shouldSyncWidth: true, theme: wideSelectboxTheme, selectedIcon: _react2.default.createElement(_listItemTickIcon.ListItemTickIcon, null), caretIcon: _react2.default.createElement(_smallDropdownArrowIcon.SmallDropDownArrowIcon, null) }, _react2.default.createElement(_Menu.MenuItem, { value: "superman" }, "Superman"), _react2.default.createElement(_Menu.MenuItem, { value: "batman" }, "Batman"), _react2.default.createElement(_Menu.MenuItem, { value: "flash" }, "Flash"))));
        }
    }]);

    return SelectboxPage;
}(_react2.default.Component);
SelectboxPage = tslib_1.__decorate([_pure.PURE], SelectboxPage);
(0, _storybook.storiesOf)('Selectbox', module).add('default', function () {
    return _react2.default.createElement(SelectboxPage, null);
});