/// <reference types="react" />
import { TButtonProps, TFullButtonProps } from '../Button/Button';
import { ComponentClass, ReactNode } from 'react';
import { ObjectClean, ObjectOmit } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/lib/object/object';
export declare type TFullSelectboxAnchorProps = ObjectOmit<TButtonProps, 'theme'> & {
    theme: TFullButtonProps['theme'] & {
        text?: string;
        content?: string;
        wrapperCaret?: string;
        caret?: string;
        container_isOpened?: string;
    };
    isOpened?: boolean;
    caretIcon?: ReactNode;
    value?: string | number;
    valueText?: ReactNode;
};
export declare type TSelectboxAnchorProps = ObjectClean<PartialKeys<TFullSelectboxAnchorProps, 'theme'>>;
export declare const SelectboxAnchor: ComponentClass<TSelectboxAnchorProps>;
